/* Code generated by cmd/cgo; DO NOT EDIT. */

/* package command-line-arguments */


#line 1 "cgo-builtin-export-prolog"

#include <stddef.h>

#ifndef GO_CGO_EXPORT_PROLOGUE_H
#define GO_CGO_EXPORT_PROLOGUE_H

#ifndef GO_CGO_GOSTRING_TYPEDEF
typedef struct { const char *p; ptrdiff_t n; } _GoString_;
#endif

#endif

/* Start of preamble from import "C" comments.  */


#line 3 "lib.go"

#include <stdio.h>
#include <stdlib.h>

// FastaRecord
typedef struct {
    char* identifier;
    char* sequence;
} FastaRecord;

// FastqOptional
typedef struct {
    char* key;
    char* value;
} FastqOptional;

// FastqRecord
typedef struct {
    char* identifier;
    FastqOptional* optionals;
    int optionals_count;
    char* sequence;
    char* quality;
} FastqRecord;

// GenbankLocation
typedef struct GenbankLocation {
    int start;
    int end;
    int complement;
    int join;
    int five_prime_partial;
    int three_prime_partial;
    char* gbk_location_string;
    struct GenbankLocation* sub_locations;
    int sub_locations_count;
} GenbankLocation;

// GenbankFeature
typedef struct {
    char* type_;
    char* description;
    char** attribute_keys;
    char*** attribute_values;
    int* attribute_value_counts;
    int attribute_count;
    char* sequence_hash;
    char* sequence_hash_function;
    char* sequence;
    GenbankLocation location;
} GenbankFeature;

// GenbankReference
typedef struct {
    char* authors;
    char* title;
    char* journal;
    char* pub_med;
    char* remark;
    char* range_;
    char* consortium;
} GenbankReference;

// GenbankLocus
typedef struct {
    char* name;
    char* sequence_length;
    char* molecule_type;
    char* genbank_division;
    char* modification_date;
    char* sequence_coding;
    int circular;
} GenbankLocus;

// GenbankBaseCount
typedef struct {
    char base;
    int count;
} GenbankBaseCount;

// GenbankMeta
typedef struct {
    char* date;
    char* definition;
    char* accession;
    char* version;
    char* keywords;
    char* organism;
    char* source;
    char** taxonomy;
    int taxonomy_count;
    char* origin;
    GenbankLocus locus;
    GenbankReference* references;
    int reference_count;
    GenbankBaseCount* base_counts;
    int base_count_count;
    char** other_keys;
    char** other_values;
    int other_count;
    char* name;
    char* sequence_hash;
    char* sequence_hash_function;
} GenbankMeta;

// Genbank
typedef struct {
    GenbankMeta meta;
    GenbankFeature* features;
    int feature_count;
    char* sequence;
} Genbank;

#line 1 "cgo-generated-wrapper"


/* End of preamble from import "C" comments.  */


/* Start of boilerplate cgo prologue.  */
#line 1 "cgo-gcc-export-header-prolog"

#ifndef GO_CGO_PROLOGUE_H
#define GO_CGO_PROLOGUE_H

typedef signed char GoInt8;
typedef unsigned char GoUint8;
typedef short GoInt16;
typedef unsigned short GoUint16;
typedef int GoInt32;
typedef unsigned int GoUint32;
typedef long long GoInt64;
typedef unsigned long long GoUint64;
typedef GoInt64 GoInt;
typedef GoUint64 GoUint;
typedef size_t GoUintptr;
typedef float GoFloat32;
typedef double GoFloat64;
#ifdef _MSC_VER
#include <complex.h>
typedef _Fcomplex GoComplex64;
typedef _Dcomplex GoComplex128;
#else
typedef float _Complex GoComplex64;
typedef double _Complex GoComplex128;
#endif

/*
  static assertion to make sure the file is being used on architecture
  at least with matching size of GoInt.
*/
typedef char _check_for_64_bit_pointer_matching_GoInt[sizeof(void*)==64/8 ? 1:-1];

#ifndef GO_CGO_GOSTRING_TYPEDEF
typedef _GoString_ GoString;
#endif
typedef void *GoMap;
typedef void *GoChan;
typedef struct { void *t; void *v; } GoInterface;
typedef struct { void *data; GoInt len; GoInt cap; } GoSlice;

#endif

/* End of boilerplate cgo prologue.  */

#ifdef __cplusplus
extern "C" {
#endif


/* Return type for ParseFastaFromCFile */
struct ParseFastaFromCFile_return {
	FastaRecord* r0;
	GoInt r1;
	char* r2;
};
extern struct ParseFastaFromCFile_return ParseFastaFromCFile(FILE* cfile);

/* Return type for ParseFastaFromCString */
struct ParseFastaFromCString_return {
	FastaRecord* r0;
	GoInt r1;
	char* r2;
};
extern struct ParseFastaFromCString_return ParseFastaFromCString(char* cstring);

/* Return type for ParseFastqFromCFile */
struct ParseFastqFromCFile_return {
	FastqRecord* r0;
	GoInt r1;
	char* r2;
};
extern struct ParseFastqFromCFile_return ParseFastqFromCFile(FILE* cfile);

/* Return type for ParseFastqFromCString */
struct ParseFastqFromCString_return {
	FastqRecord* r0;
	GoInt r1;
	char* r2;
};
extern struct ParseFastqFromCString_return ParseFastqFromCString(char* cstring);

/* Return type for ParseGenbankFromCFile */
struct ParseGenbankFromCFile_return {
	Genbank* r0;
	GoInt r1;
	char* r2;
};
extern struct ParseGenbankFromCFile_return ParseGenbankFromCFile(FILE* cfile);

/* Return type for ParseGenbankFromCString */
struct ParseGenbankFromCString_return {
	Genbank* r0;
	GoInt r1;
	char* r2;
};
extern struct ParseGenbankFromCString_return ParseGenbankFromCString(char* cstring);

#ifdef __cplusplus
}
#endif
